LeetCode 167. Two Sum II - Input array is sorted (Java版; Easy)

welcome to my blog

LeetCode 167. Two Sum II - Input array is sorted (Java版; Easy)

题目描述

Given an array of integers that is already sorted in ascending order, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2.

Note:

Your returned answers (both index1 and index2) are not zero-based.
You may assume that each input would have exactly one solution and you may not use the same element twice.
Example:

Input: numbers = [2,7,11,15], target = 9
Output: [1,2]
Explanation: The sum of 2 and 7 is 9. Therefore index1 = 1, index2 = 2.

第一次做; 双指针, 从两端向中间; 是否需要考虑 numbers[left] + numbers[right] 溢出?不需要。因为存在唯一解,所以即使溢出也能得到答案

/*
双指针, 从两端向中间
*/
class Solution {
    public int[] twoSum(int[] numbers, int target) {
        int n=numbers.length, left=0, right=n-1;
        while(left<right){
            int sum = numbers[left] + numbers[right];
            if(sum > target){
                right--;
            }
            else if(sum < target){
                left++;
            }
            else
                break;
        }
        return new int[]{left+1, right+1};
    }
}

双指针压缩搜索空间的原理

发布了580 篇原创文章 · 获赞 130 · 访问量 18万+

猜你喜欢

转载自blog.csdn.net/littlehaes/article/details/104227821